namespace ProjectExcavator
{
    public partial class FormExcavator : Form
    {

        private DrawingExcavator? _drawingExcavator;
        public FormExcavator()
        {
            InitializeComponent();
        }

        private void Draw()
        {
            if (_drawingExcavator == null)
            {
                return;
            }
            Bitmap bmp = new(pictureBoxExcavator.Width, pictureBoxExcavator.Height);
            Graphics g = Graphics.FromImage(bmp);
            _drawingExcavator.DrawTransport(g);
            pictureBoxExcavator.Image = bmp;
        }

        private void buttonCreate_Click(object sender, EventArgs e)
        {
            Random random = new();
            _drawingExcavator = new DrawingExcavator();
            _drawingExcavator.Init(random.Next(300, 1000), random.Next(1000, 2000),
                Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                Color.FromArgb(random.Next(0, 256), random.Next(0, 256), random.Next(0, 256)),
                Convert.ToBoolean(random.Next(0, 2)),
                Convert.ToBoolean(random.Next(0, 2)),
                pictureBoxExcavator.Width, pictureBoxExcavator.Height);
            _drawingExcavator.SetPosition(random.Next(100, 300), random.Next(100, 300));
            Draw();
        }

        private void buttonMove_Click(object sender, EventArgs e)
        {
            if (_drawingExcavator == null)
            {
                return;
            }
            string name = ((Button)sender)?.Name ?? string.Empty;
            switch (name)
            {
                case "buttonUp":
                    _drawingExcavator.MoveTransport(DirectionType.Up);
                    break;
                case "buttonDown":
                    _drawingExcavator.MoveTransport(DirectionType.Down);
                    break;
                case "buttonLeft":
                    _drawingExcavator.MoveTransport(DirectionType.Left);
                    break;
                case "buttonRight":
                    _drawingExcavator.MoveTransport(DirectionType.Right);
                    break;
            }
            Draw();
        }
    }
}